## tcc 0.9.20

=== Makefile ===
#
# Tiny C Compiler Makefile
#
include config.mak

CFLAGS=-O2 -g -Wall
LIBS=-ldl
CFLAGS_P=$(CFLAGS) -pg -static -DCONFIG_TCC_STATIC
LIBS_P=

CFLAGS+=-mpreferred-stack-boundary=2
ifeq ($(GCC_MAJOR),2)
CFLAGS+=-m386 -malign-functions=0
else
CFLAGS+=-march=i386 -falign-functions=0
endif

DISAS=objdump -d
INSTALL=install

# run local version of tcc with local libraries and includes
TCC=./tcc -B. -I.

all: tcc libtcc1.a bcheck.o tcc-doc.html tcc.1 libtcc.a libtcc_test

Makefile: config.mak

# auto test

test: test.ref test.out
	@if diff -u test.ref test.out ; then echo "Auto Test OK"; fi

tcctest.ref: tcctest.c 
	$(CC) $(CFLAGS) -I. -o $@ $<

test.ref: tcctest.ref
	./tcctest.ref > $@

test.out: tcc tcctest.c
	$(TCC) -run tcctest.c > $@

run: tcc tcctest.c
	$(TCC) -run tcctest.c

# iterated test2 (compile tcc then compile tcctest.c !)
test2: tcc tcc.c tcctest.c test.ref
	$(TCC) -run tcc.c -B. -I. -run tcctest.c > test.out2
	@if diff -u test.ref test.out2 ; then echo "Auto Test2 OK"; fi

# iterated test3 (compile tcc then compile tcc then compile tcctest.c !)
test3: tcc tcc.c tcctest.c test.ref
	$(TCC) -run tcc.c -B. -I. -run tcc.c -B. -I. -run tcctest.c > test.out3
	@if diff -u test.ref test.out3 ; then echo "Auto Test3 OK"; fi

# binary output test
test4: tcc test.ref
# dynamic output
	$(TCC) -o tcctest1 tcctest.c
	./tcctest1 > test1.out
	@if diff -u test.ref test1.out ; then echo "Dynamic Auto Test OK"; fi
# static output
	$(TCC) -static -o tcctest2 tcctest.c
	./tcctest2 > test2.out
	@if diff -u test.ref test2.out ; then echo "Static Auto Test OK"; fi
# object + link output
	$(TCC) -c -o tcctest3.o tcctest.c
	$(TCC) -o tcctest3 tcctest3.o
	./tcctest3 > test3.out
	@if diff -u test.ref test3.out ; then echo "Object Auto Test OK"; fi
# dynamic output + bound check
	$(TCC) -b -o tcctest4 tcctest.c
	./tcctest4 > test4.out
	@if diff -u test.ref test4.out ; then echo "BCheck Auto Test OK"; fi

# memory and bound check auto test
BOUNDS_OK  = 1 4 8 10
BOUNDS_FAIL= 2 5 7 9 11 12 13

btest: boundtest.c tcc
	@for i in $(BOUNDS_OK); do \
           if $(TCC) -b -run boundtest.c $$i ; then \
               /bin/true ; \
           else\
	       echo Failed positive test $$i ; exit 1 ; \
           fi ;\
        done ;\
        for i in $(BOUNDS_FAIL); do \
           if $(TCC) -b -run boundtest.c $$i ; then \
	       echo Failed negative test $$i ; exit 1 ;\
           else\
               /bin/true ; \
           fi\
        done ;\
        echo Bound test OK

# speed test
speed: tcc ex2 ex3
	time ./ex2 1238 2 3 4 10 13 4
	time ./tcc -I. ./ex2.c 1238 2 3 4 10 13 4
	time ./ex3 35
	time ./tcc -I. ./ex3.c 35

ex2: ex2.c
	$(CC) $(CFLAGS) -o $@ $<

ex3: ex3.c
	$(CC) $(CFLAGS) -o $@ $<

# Native Tiny C Compiler

tcc_g: tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h Makefile
	$(CC) $(CFLAGS) -o $@ $< $(LIBS)

tcc: tcc_g Makefile
	strip -s -R .comment -R .note -o $@ $<

# TinyCC runtime libraries
libtcc1.o: libtcc1.c
	$(CC) -O2 -Wall -c -o $@ $<

libtcc1.a: libtcc1.o
	$(AR) rcs $@ $^

bcheck.o: bcheck.c
	$(CC) -O2 -Wall -c -o $@ $<

install: tcc_install libinstall

tcc_install: tcc tcc.1 libtcc1.a bcheck.o
	$(INSTALL) -m755 tcc $(bindir)
	$(INSTALL) tcc.1 $(mandir)/man1
	mkdir -p $(libdir)/tcc
	mkdir -p $(libdir)/tcc/include
	$(INSTALL) -m644 libtcc1.a bcheck.o $(libdir)/tcc
	$(INSTALL) -m644 stdarg.h stddef.h stdbool.h float.h varargs.h \
                   tcclib.h $(libdir)/tcc/include

clean:
	rm -f *~ *.o tcc tcc1 tcct tcc_g tcctest.ref *.bin *.i ex2 \
           core gmon.out test.out test.ref a.out tcc_p \
           *.exe tcc-doc.html tcc.pod tcc.1 libtcc.a libtcc_test \
           tcctest[1234] test[1234].out

distclean: clean
	rm -f config.h config.mak config.texi

# win32 TCC
tcc_g.exe: tcc.c i386-gen.c bcheck.c Makefile
	i386-mingw32msvc-gcc $(CFLAGS) -DCONFIG_TCC_STATIC -o $@ $<

tcc.exe: tcc_g.exe
	i386-mingw32msvc-strip -o $@ $<

# profiling version
tcc_p: tcc.c Makefile
	$(CC) $(CFLAGS_P) -o $@ $< $(LIBS_P)

# libtcc generation and example
libinstall: libtcc.a 
	$(INSTALL) -m644 libtcc.a $(libdir)
	$(INSTALL) -m644 libtcc.h $(includedir)

libtcc.o: tcc.c i386-gen.c bcheck.c Makefile
	$(CC) $(CFLAGS) -DLIBTCC -c -o $@ $<

libtcc.a: libtcc.o 
	$(AR) rcs $@ $^

libtcc_test: libtcc_test.c libtcc.a 
	$(CC) $(CFLAGS) -I. -o $@ $< -L. -ltcc -ldl

libtest: libtcc_test
	./libtcc_test

# targets for development

%.bin: %.c tcc
	$(TCC) -g -o $@ $<
	$(DISAS) $@

instr: instr.o
	objdump -d instr.o

# tiny assembler testing

asmtest.ref: asmtest.S
	$(CC) -c -o asmtest.ref.o asmtest.S
	objdump -D asmtest.ref.o > $@

# XXX: we compute tcc.c to go faster during development !
asmtest.out: asmtest.S tcc
#	./tcc tcc.c -c asmtest.S
#asmtest.out: asmtest.S tcc
	./tcc -c asmtest.S
	objdump -D asmtest.o > $@

asmtest: asmtest.out asmtest.ref
	@if diff -u --ignore-matching-lines="file format" asmtest.ref asmtest.out ; then echo "ASM Auto Test OK"; fi

instr.o: instr.S
	$(CC) -O2 -Wall -g -c -o $@ $<

cache: tcc_g
	cachegrind ./tcc_g -o /tmp/linpack -lm bench/linpack.c
	vg_annotate tcc.c > /tmp/linpack.cache.log

# documentation and man page
tcc-doc.html: tcc-doc.texi
	texi2html -monolithic -number $<

tcc.1: tcc-doc.texi
	./texi2pod.pl $< tcc.pod
	pod2man --section=1 --center=" " --release=" " tcc.pod > $@

FILES= Makefile Makefile.uClibc configure VERSION \
       README TODO COPYING \
       Changelog tcc-doc.texi tcc-doc.html \
       tcc.1 \
       tcc.c i386-gen.c tccelf.c tcctok.h tccasm.c  i386-asm.c i386-asm.h\
       bcheck.c libtcc1.c \
       elf.h stab.h stab.def \
       stddef.h stdarg.h stdbool.h float.h varargs.h \
       tcclib.h libtcc.h libtcc_test.c \
       ex1.c ex2.c ex3.c ex4.c ex5.c \
       tcctest.c boundtest.c gcctestsuite.sh texi2pod.pl

FILE=tcc-$(VERSION)

tar:
	rm -rf /tmp/$(FILE)
	mkdir -p /tmp/$(FILE)
	cp -P $(FILES) /tmp/$(FILE)
	( cd /tmp ; tar zcvf ~/$(FILE).tar.gz $(FILE) )
	rm -rf /tmp/$(FILE)

## tcc 0.9.22

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,10 @@
 include config.mak
 
 CFLAGS=-O2 -g -Wall
+ifndef CONFIG_WIN32
 LIBS=-ldl
+BCHECK_O=bcheck.o
+endif
 CFLAGS_P=$(CFLAGS) -pg -static -DCONFIG_TCC_STATIC
 LIBS_P=
 
@@ -12,16 +15,18 @@
 ifeq ($(GCC_MAJOR),2)
 CFLAGS+=-m386 -malign-functions=0
 else
-CFLAGS+=-march=i386 -falign-functions=0
+CFLAGS+=-march=i386 -falign-functions=0 -fno-strict-aliasing
 endif
 
 DISAS=objdump -d
 INSTALL=install
-
+PROGS=tcc$(EXESUF) c67-tcc$(EXESUF) arm-tcc$(EXESUF)
 # run local version of tcc with local libraries and includes
 TCC=./tcc -B. -I.
 
-all: tcc libtcc1.a bcheck.o tcc-doc.html tcc.1 libtcc.a libtcc_test
+all: $(PROGS) \
+     libtcc1$(LIBSUF) $(BCHECK_O) tcc-doc.html tcc.1 libtcc$(LIBSUF) \
+     libtcc_test$(EXESUF)
 
 Makefile: config.mak
 
@@ -108,17 +113,23 @@
 
 # Native Tiny C Compiler
 
-tcc_g: tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h Makefile
+tcc_g$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h Makefile
 	$(CC) $(CFLAGS) -o $@ $< $(LIBS)
 
-tcc: tcc_g Makefile
-	strip -s -R .comment -R .note -o $@ $<
+tcc$(EXESUF): tcc_g$(EXESUF) Makefile
+	$(STRIP) -o $@ $<
+
+c67-tcc$(EXESUF): tcc.c c67-gen.c tccelf.c tccasm.c tcctok.h libtcc.h tcccoff.c Makefile
+	$(CC) $(CFLAGS) -DTCC_TARGET_C67 -o $@ $< $(LIBS)
+
+arm-tcc$(EXESUF): tcc.c arm-gen.c tccelf.c tccasm.c tcctok.h libtcc.h Makefile
+	$(CC) $(CFLAGS) -DTCC_TARGET_ARM -o $@ $< $(LIBS)
 
 # TinyCC runtime libraries
 libtcc1.o: libtcc1.c
 	$(CC) -O2 -Wall -c -o $@ $<
 
-libtcc1.a: libtcc1.o
+libtcc1$(LIBSUF): libtcc1.o
 	$(AR) rcs $@ $^
 
 bcheck.o: bcheck.c
@@ -126,48 +137,49 @@
 
 install: tcc_install libinstall
 
-tcc_install: tcc tcc.1 libtcc1.a bcheck.o
-	$(INSTALL) -m755 tcc $(bindir)
-	$(INSTALL) tcc.1 $(mandir)/man1
-	mkdir -p $(libdir)/tcc
-	mkdir -p $(libdir)/tcc/include
-	$(INSTALL) -m644 libtcc1.a bcheck.o $(libdir)/tcc
+tcc_install: $(PROGS) tcc.1 libtcc1$(LIBSUF) $(BCHECK_O) tcc-doc.html tcc.1
+	mkdir -p "$(bindir)"
+	$(INSTALL) -s -m755 $(PROGS) "$(bindir)"
+ifndef CONFIG_WIN32
+	mkdir -p "$(mandir)/man1"
+	$(INSTALL) tcc.1 "$(mandir)/man1"
+endif
+	mkdir -p "$(libdir)/tcc"
+	mkdir -p "$(libdir)/tcc/include"
+	$(INSTALL) -m644 libtcc1$(LIBSUF) $(BCHECK_O) "$(libdir)/tcc"
 	$(INSTALL) -m644 stdarg.h stddef.h stdbool.h float.h varargs.h \
-                   tcclib.h $(libdir)/tcc/include
+                   tcclib.h "$(libdir)/tcc/include"
+	mkdir -p "$(docdir)"
+	$(INSTALL) -m644 tcc-doc.html "$(docdir)"
 
 clean:
 	rm -f *~ *.o tcc tcc1 tcct tcc_g tcctest.ref *.bin *.i ex2 \
            core gmon.out test.out test.ref a.out tcc_p \
-           *.exe tcc-doc.html tcc.pod tcc.1 libtcc.a libtcc_test \
-           tcctest[1234] test[1234].out
+           *.exe tcc-doc.html tcc.pod tcc.1 libtcc$(LIBSUF) libtcc_test \
+           tcctest[1234] test[1234].out c67-tcc arm-tcc
 
 distclean: clean
 	rm -f config.h config.mak config.texi
-
-# win32 TCC
-tcc_g.exe: tcc.c i386-gen.c bcheck.c Makefile
-	i386-mingw32msvc-gcc $(CFLAGS) -DCONFIG_TCC_STATIC -o $@ $<
-
-tcc.exe: tcc_g.exe
-	i386-mingw32msvc-strip -o $@ $<
 
 # profiling version
 tcc_p: tcc.c Makefile
 	$(CC) $(CFLAGS_P) -o $@ $< $(LIBS_P)
 
 # libtcc generation and example
-libinstall: libtcc.a 
-	$(INSTALL) -m644 libtcc.a $(libdir)
-	$(INSTALL) -m644 libtcc.h $(includedir)
-
-libtcc.o: tcc.c i386-gen.c bcheck.c Makefile
+libinstall: libtcc$(LIBSUF) 
+	mkdir -p "$(libdir)"
+	$(INSTALL) -m644 libtcc$(LIBSUF) "$(libdir)"
+	mkdir -p "$(includedir)"
+	$(INSTALL) -m644 libtcc.h "$(includedir)"
+
+libtcc.o: tcc.c i386-gen.c Makefile
 	$(CC) $(CFLAGS) -DLIBTCC -c -o $@ $<
 
-libtcc.a: libtcc.o 
+libtcc$(LIBSUF): libtcc.o 
 	$(AR) rcs $@ $^
 
-libtcc_test: libtcc_test.c libtcc.a 
-	$(CC) $(CFLAGS) -I. -o $@ $< -L. -ltcc -ldl
+libtcc_test$(EXESUF): libtcc_test.c libtcc$(LIBSUF)
+	$(CC) $(CFLAGS) -o $@ $< libtcc$(LIBSUF) $(LIBS)
 
 libtest: libtcc_test
 	./libtcc_test
@@ -216,7 +228,9 @@
        README TODO COPYING \
        Changelog tcc-doc.texi tcc-doc.html \
        tcc.1 \
-       tcc.c i386-gen.c tccelf.c tcctok.h tccasm.c  i386-asm.c i386-asm.h\
+       tcc.c tccelf.c tcctok.h tccasm.c i386-asm.c i386-asm.h \
+       tcccoff.c coff.h \
+       i386-gen.c c67-gen.c arm-gen.c \
        bcheck.c libtcc1.c \
        elf.h stab.h stab.def \
        stddef.h stdarg.h stdbool.h float.h varargs.h \

## tcc 0.9.23

=== Makefile ===
--- 
+++ 
@@ -20,12 +20,36 @@
 
 DISAS=objdump -d
 INSTALL=install
-PROGS=tcc$(EXESUF) c67-tcc$(EXESUF) arm-tcc$(EXESUF)
+
+ifdef CONFIG_WIN32
+PROGS=tcc$(EXESUF)
+ifdef CONFIG_CROSS
+PROGS+=c67-tcc$(EXESUF) arm-tcc$(EXESUF)
+endif
+PROGS+=tiny_impdef$(EXESUF)
+else
+ifeq ($(ARCH),i386)
+PROGS=tcc$(EXESUF)
+ifdef CONFIG_CROSS
+PROGS+=arm-tcc$(EXESUF)
+endif
+endif
+ifeq ($(ARCH),arm)
+PROGS=tcc$(EXESUF)
+ifdef CONFIG_CROSS
+PROGS+=i386-tcc$(EXESUF)
+endif
+endif
+ifdef CONFIG_CROSS
+PROGS+=c67-tcc$(EXESUF) i386-win32-tcc$(EXESUF)
+endif
+endif
+
 # run local version of tcc with local libraries and includes
 TCC=./tcc -B. -I.
 
 all: $(PROGS) \
-     libtcc1$(LIBSUF) $(BCHECK_O) tcc-doc.html tcc.1 libtcc$(LIBSUF) \
+     libtcc1.a $(BCHECK_O) tcc-doc.html tcc.1 libtcc.a \
      libtcc_test$(EXESUF)
 
 Makefile: config.mak
@@ -111,25 +135,55 @@
 ex3: ex3.c
 	$(CC) $(CFLAGS) -o $@ $<
 
-# Native Tiny C Compiler
-
-tcc_g$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h Makefile
+# Host Tiny C Compiler
+ifdef CONFIG_WIN32
+tcc$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h tccpe.c
+	$(CC) $(CFLAGS) -DTCC_TARGET_PE -o $@ $< $(LIBS)
+else
+ifeq ($(ARCH),i386)
+tcc$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h
 	$(CC) $(CFLAGS) -o $@ $< $(LIBS)
-
-tcc$(EXESUF): tcc_g$(EXESUF) Makefile
-	$(STRIP) -o $@ $<
-
-c67-tcc$(EXESUF): tcc.c c67-gen.c tccelf.c tccasm.c tcctok.h libtcc.h tcccoff.c Makefile
+endif
+ifeq ($(ARCH),arm)
+tcc$(EXESUF): tcc.c arm-gen.c tccelf.c tccasm.c tcctok.h libtcc.h
+	$(CC) $(CFLAGS) -DTCC_TARGET_ARM -o $@ $< $(LIBS)
+endif
+endif
+
+# Cross Tiny C Compilers
+i386-tcc$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h
+	$(CC) $(CFLAGS) -o $@ $< $(LIBS)
+
+c67-tcc$(EXESUF): tcc.c c67-gen.c tccelf.c tccasm.c tcctok.h libtcc.h tcccoff.c
 	$(CC) $(CFLAGS) -DTCC_TARGET_C67 -o $@ $< $(LIBS)
 
-arm-tcc$(EXESUF): tcc.c arm-gen.c tccelf.c tccasm.c tcctok.h libtcc.h Makefile
+arm-tcc$(EXESUF): tcc.c arm-gen.c tccelf.c tccasm.c tcctok.h libtcc.h
 	$(CC) $(CFLAGS) -DTCC_TARGET_ARM -o $@ $< $(LIBS)
 
+i386-win32-tcc$(EXESUF): tcc.c i386-gen.c tccelf.c tccasm.c i386-asm.c tcctok.h libtcc.h i386-asm.h tccpe.c
+	$(CC) $(CFLAGS) -DTCC_TARGET_PE -o $@ $< $(LIBS)
+
+# windows utilities
+tiny_impdef$(EXESUF): tiny_impdef.c
+	$(CC) $(CFLAGS) -o $@ $< -lkernel32
+
 # TinyCC runtime libraries
-libtcc1.o: libtcc1.c
-	$(CC) -O2 -Wall -c -o $@ $<
-
-libtcc1$(LIBSUF): libtcc1.o
+ifdef CONFIG_WIN32
+# for windows, we must use TCC because we generate ELF objects
+LIBTCC1_OBJS=$(addprefix win32/lib/, crt1.o wincrt1.o dllcrt1.o dllmain.o chkstk.o) libtcc1.o
+LIBTCC1_CC=./tcc.exe -Bwin32
+else
+LIBTCC1_OBJS=libtcc1.o
+LIBTCC1_CC=$(CC)
+endif
+
+%.o: %.c
+	$(LIBTCC1_CC) -O2 -Wall -c -o $@ $<
+
+%.o: %.S
+	$(LIBTCC1_CC) -c -o $@ $<
+
+libtcc1.a: $(LIBTCC1_OBJS)
 	$(AR) rcs $@ $^
 
 bcheck.o: bcheck.c
@@ -137,26 +191,36 @@
 
 install: tcc_install libinstall
 
-tcc_install: $(PROGS) tcc.1 libtcc1$(LIBSUF) $(BCHECK_O) tcc-doc.html tcc.1
+tcc_install: $(PROGS) tcc.1 libtcc1.a $(BCHECK_O) tcc-doc.html tcc.1
 	mkdir -p "$(bindir)"
 	$(INSTALL) -s -m755 $(PROGS) "$(bindir)"
 ifndef CONFIG_WIN32
 	mkdir -p "$(mandir)/man1"
 	$(INSTALL) tcc.1 "$(mandir)/man1"
 endif
-	mkdir -p "$(libdir)/tcc"
-	mkdir -p "$(libdir)/tcc/include"
-	$(INSTALL) -m644 libtcc1$(LIBSUF) $(BCHECK_O) "$(libdir)/tcc"
+	mkdir -p "$(tccdir)"
+	mkdir -p "$(tccdir)/include"
+ifdef CONFIG_WIN32
+	mkdir -p "$(tccdir)/lib"
+	$(INSTALL) -m644 libtcc1.a win32/lib/*.def "$(tccdir)/lib"
+	cp -r win32/include/. "$(tccdir)/include"
+	cp -r win32/examples/. "$(tccdir)/examples"
+else
+	$(INSTALL) -m644 libtcc1.a $(BCHECK_O) "$(tccdir)"
 	$(INSTALL) -m644 stdarg.h stddef.h stdbool.h float.h varargs.h \
-                   tcclib.h "$(libdir)/tcc/include"
+                   tcclib.h "$(tccdir)/include"
+endif
 	mkdir -p "$(docdir)"
 	$(INSTALL) -m644 tcc-doc.html "$(docdir)"
+ifdef CONFIG_WIN32
+	$(INSTALL) -m644 win32/readme.txt "$(docdir)"
+endif
 
 clean:
-	rm -f *~ *.o tcc tcc1 tcct tcc_g tcctest.ref *.bin *.i ex2 \
+	rm -f *~ *.o *.a tcc tcc1 tcct tcc_g tcctest.ref *.bin *.i ex2 \
            core gmon.out test.out test.ref a.out tcc_p \
-           *.exe tcc-doc.html tcc.pod tcc.1 libtcc$(LIBSUF) libtcc_test \
-           tcctest[1234] test[1234].out c67-tcc arm-tcc
+           *.exe *.lib tcc.pod libtcc_test \
+           tcctest[1234] test[1234].out $(PROGS) win32/lib/*.o
 
 distclean: clean
 	rm -f config.h config.mak config.texi
@@ -166,20 +230,20 @@
 	$(CC) $(CFLAGS_P) -o $@ $< $(LIBS_P)
 
 # libtcc generation and example
-libinstall: libtcc$(LIBSUF) 
+libinstall: libtcc.a 
 	mkdir -p "$(libdir)"
-	$(INSTALL) -m644 libtcc$(LIBSUF) "$(libdir)"
+	$(INSTALL) -m644 libtcc.a "$(libdir)"
 	mkdir -p "$(includedir)"
 	$(INSTALL) -m644 libtcc.h "$(includedir)"
 
 libtcc.o: tcc.c i386-gen.c Makefile
 	$(CC) $(CFLAGS) -DLIBTCC -c -o $@ $<
 
-libtcc$(LIBSUF): libtcc.o 
+libtcc.a: libtcc.o 
 	$(AR) rcs $@ $^
 
-libtcc_test$(EXESUF): libtcc_test.c libtcc$(LIBSUF)
-	$(CC) $(CFLAGS) -o $@ $< libtcc$(LIBSUF) $(LIBS)
+libtcc_test$(EXESUF): libtcc_test.c libtcc.a
+	$(CC) $(CFLAGS) -o $@ $< libtcc.a $(LIBS)
 
 libtest: libtcc_test
 	./libtcc_test
@@ -224,25 +288,11 @@
 	./texi2pod.pl $< tcc.pod
 	pod2man --section=1 --center=" " --release=" " tcc.pod > $@
 
-FILES= Makefile Makefile.uClibc configure VERSION \
-       README TODO COPYING \
-       Changelog tcc-doc.texi tcc-doc.html \
-       tcc.1 \
-       tcc.c tccelf.c tcctok.h tccasm.c i386-asm.c i386-asm.h \
-       tcccoff.c coff.h \
-       i386-gen.c c67-gen.c arm-gen.c \
-       bcheck.c libtcc1.c \
-       elf.h stab.h stab.def \
-       stddef.h stdarg.h stdbool.h float.h varargs.h \
-       tcclib.h libtcc.h libtcc_test.c \
-       ex1.c ex2.c ex3.c ex4.c ex5.c \
-       tcctest.c boundtest.c gcctestsuite.sh texi2pod.pl
-
-FILE=tcc-$(VERSION)
-
+FILE=tcc-$(shell cat VERSION)
+
+# tar release (use 'make -k tar' on a checkouted tree)
 tar:
 	rm -rf /tmp/$(FILE)
-	mkdir -p /tmp/$(FILE)
-	cp -P $(FILES) /tmp/$(FILE)
-	( cd /tmp ; tar zcvf ~/$(FILE).tar.gz $(FILE) )
+	cp -r . /tmp/$(FILE)
+	( cd /tmp ; tar zcvf ~/$(FILE).tar.gz $(FILE) --exclude CVS )
 	rm -rf /tmp/$(FILE)

## tcc 0.9.24~cvs20070502

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 include config.mak
 
-CFLAGS=-O2 -g -Wall
+CFLAGS+=-g -Wall
 ifndef CONFIG_WIN32
 LIBS=-ldl
 BCHECK_O=bcheck.o
@@ -191,7 +191,7 @@
 
 install: tcc_install libinstall
 
-tcc_install: $(PROGS) tcc.1 libtcc1.a $(BCHECK_O) tcc-doc.html tcc.1
+tcc_install: $(PROGS) tcc.1 libtcc1.a $(BCHECK_O) tcc-doc.html
 	mkdir -p "$(bindir)"
 	$(INSTALL) -s -m755 $(PROGS) "$(bindir)"
 ifndef CONFIG_WIN32
@@ -217,7 +217,7 @@
 endif
 
 clean:
-	rm -f *~ *.o *.a tcc tcc1 tcct tcc_g tcctest.ref *.bin *.i ex2 \
+	rm -f *~ *.o *.a tcc tcct tcc_g tcctest.ref *.bin *.i ex2 \
            core gmon.out test.out test.ref a.out tcc_p \
            *.exe *.lib tcc.pod libtcc_test \
            tcctest[1234] test[1234].out $(PROGS) win32/lib/*.o

## tcc 0.9.25

=== Makefile ===
#
# Tiny C Compiler Makefile
#

TOP ?= .
include $(TOP)/config.mak

CFLAGS+=-g -Wall
CFLAGS_P=$(CFLAGS) -pg -static -DCONFIG_TCC_STATIC
LIBS_P=

ifneq ($(GCC_MAJOR),2)
CFLAGS+=-fno-strict-aliasing
endif

ifeq ($(ARCH),i386)
CFLAGS+=-mpreferred-stack-boundary=2
ifeq ($(GCC_MAJOR),2)
CFLAGS+=-m386 -malign-functions=0
else
CFLAGS+=-march=i386 -falign-functions=0
ifneq ($(GCC_MAJOR),3)
CFLAGS+=-Wno-pointer-sign -Wno-sign-compare -D_FORTIFY_SOURCE=0
endif
endif
endif

ifeq ($(ARCH),x86-64)
CFLAGS+=-Wno-pointer-sign
endif

ifndef CONFIG_WIN32
LIBS=-lm
ifndef CONFIG_NOLDL
LIBS+=-ldl
endif
endif

ifdef CONFIG_WIN32
NATIVE_TARGET=-DTCC_TARGET_PE
LIBTCC1=libtcc1.a
else
ifeq ($(ARCH),i386)
NATIVE_TARGET=-DTCC_TARGET_I386
LIBTCC1=libtcc1.a
BCHECK_O=bcheck.o
else
ifeq ($(ARCH),arm)
NATIVE_TARGET=-DTCC_TARGET_ARM
NATIVE_TARGET+=$(if $(wildcard /lib/ld-linux.so.3),-DTCC_ARM_EABI)
NATIVE_TARGET+=$(if $(shell grep -l "^Features.* \(vfp\|iwmmxt\) " /proc/cpuinfo),-DTCC_ARM_VFP)
else
ifeq ($(ARCH),x86-64)
NATIVE_TARGET=-DTCC_TARGET_X86_64
LIBTCC1=libtcc1.a
endif
endif
endif
endif

ifneq ($(wildcard /lib/ld-uClibc.so.0),)
NATIVE_TARGET+=-DTCC_UCLIBC
BCHECK_O=
endif

ifdef CONFIG_USE_LIBGCC
LIBTCC1=
endif

ifeq ($(TOP),.)

PROGS=tcc$(EXESUF)

I386_CROSS = i386-tcc$(EXESUF)
WIN32_CROSS = i386-win32-tcc$(EXESUF)
X64_CROSS = x86_64-tcc$(EXESUF)
ARM_CROSS = arm-tcc-fpa$(EXESUF) arm-tcc-fpa-ld$(EXESUF) \
    arm-tcc-vfp$(EXESUF) arm-tcc-vfp-eabi$(EXESUF)
C67_CROSS = c67-tcc$(EXESUF)

CORE_FILES = tcc.c libtcc.c tccpp.c tccgen.c tccelf.c tccasm.c \
    tcc.h config.h libtcc.h tcctok.h
I386_FILES = $(CORE_FILES) i386-gen.c i386-asm.c i386-asm.h
WIN32_FILES = $(CORE_FILES) i386-gen.c i386-asm.c i386-asm.h tccpe.c
X86_64_FILES = $(CORE_FILES) x86_64-gen.c
ARM_FILES = $(CORE_FILES) arm-gen.c
C67_FILES = $(CORE_FILES) c67-gen.c tcccoff.c

ifdef CONFIG_WIN32
PROGS+=tiny_impdef$(EXESUF) tiny_libmaker$(EXESUF)
NATIVE_FILES=$(WIN32_FILES)
PROGS_CROSS=$(I386_CROSS) $(X64_CROSS) $(ARM_CROSS) $(C67_CROSS)
else
ifeq ($(ARCH),i386)
NATIVE_FILES=$(I386_FILES)
PROGS_CROSS=$(X64_CROSS) $(WIN32_CROSS) $(ARM_CROSS) $(C67_CROSS)
else
ifeq ($(ARCH),x86-64)
NATIVE_FILES=$(X86_64_FILES)
PROGS_CROSS=$(I386_CROSS) $(WIN32_CROSS) $(ARM_CROSS) $(C67_CROSS)
else
ifeq ($(ARCH),arm)
NATIVE_FILES=$(ARM_FILES)
PROGS_CROSS=$(I386_CROSS) $(X64_CROSS) $(WIN32_CROSS) $(C67_CROSS)
endif
endif
endif
endif

ifdef CONFIG_CROSS
PROGS+=$(PROGS_CROSS)
endif

all: $(PROGS) $(LIBTCC1) $(BCHECK_O) libtcc.a tcc-doc.html tcc.1 libtcc_test$(EXESUF)

# Host Tiny C Compiler
tcc$(EXESUF): $(NATIVE_FILES)
	$(CC) -o $@ $< $(NATIVE_TARGET) $(CFLAGS) $(LIBS)

# Cross Tiny C Compilers
i386-tcc$(EXESUF): $(I386_FILES)
	$(CC) -o $@ $< -DTCC_TARGET_I386 $(CFLAGS) $(LIBS)

i386-win32-tcc$(EXESUF): $(WIN32_FILES)
	$(CC) -o $@ $< -DTCC_TARGET_PE $(CFLAGS) $(LIBS)

x86_64-tcc$(EXESUF): $(X86_64_FILES)
	$(CC) -o $@ $< -DTCC_TARGET_X86_64 $(CFLAGS) $(LIBS)

c67-tcc$(EXESUF): $(C67_FILES)
	$(CC) -o $@ $< -DTCC_TARGET_C67 $(CFLAGS) $(LIBS)

arm-tcc-fpa$(EXESUF): $(ARM_FILES)
	$(CC) -o $@ $< -DTCC_TARGET_ARM $(CFLAGS) $(LIBS)

arm-tcc-fpa-ld$(EXESUF): $(ARM_FILES)
	$(CC) -o $@ $< -DTCC_TARGET_ARM -DLDOUBLE_SIZE=12 $(CFLAGS) $(LIBS)

arm-tcc-vfp$(EXESUF): $(ARM_FILES)
	$(CC) -o $@ $< -DTCC_TARGET_ARM -DTCC_ARM_VFP $(CFLAGS) $(LIBS)

arm-tcc-vfp-eabi$(EXESUF): $(ARM_FILES)
	$(CC) -o $@ $< -DTCC_TARGET_ARM -DTCC_ARM_EABI $(CFLAGS) $(LIBS)

# libtcc generation and test
libtcc.o: $(NATIVE_FILES)
	$(CC) -o $@ -c libtcc.c $(NATIVE_TARGET) $(CFLAGS)

libtcc.a: libtcc.o
	$(AR) rcs $@ $^

libtcc_test$(EXESUF): tests/libtcc_test.c libtcc.a
	$(CC) -o $@ $^ -I. $(CFLAGS) $(LIBS)

libtest: libtcc_test$(EXESUF) $(LIBTCC1)
	./libtcc_test$(EXESUF) lib_path=.

# profiling version
tcc_p$(EXESUF): $(NATIVE_FILES)
	$(CC) -o $@ $< $(NATIVE_TARGET) $(CFLAGS_P) $(LIBS_P)

# windows utilities
tiny_impdef$(EXESUF): win32/tools/tiny_impdef.c
	$(CC) -o $@ $< $(CFLAGS)
tiny_libmaker$(EXESUF): win32/tools/tiny_libmaker.c
	$(CC) -o $@ $< $(CFLAGS)

# TinyCC runtime libraries
LIBTCC1_OBJS=libtcc1.o
LIBTCC1_CC=$(CC)
VPATH+=lib
ifdef CONFIG_WIN32
# for windows, we must use TCC because we generate ELF objects
LIBTCC1_OBJS+=crt1.o wincrt1.o dllcrt1.o dllmain.o chkstk.o
LIBTCC1_CC=./tcc.exe -Bwin32 -DTCC_TARGET_PE
VPATH+=win32/lib
endif
ifeq ($(ARCH),i386)
LIBTCC1_OBJS+=alloca86.o alloca86-bt.o
endif

%.o: %.c
	$(LIBTCC1_CC) -o $@ -c $< -O2 -Wall

%.o: %.S
	$(LIBTCC1_CC) -o $@ -c $<

libtcc1.a: $(LIBTCC1_OBJS)
	$(AR) rcs $@ $^

bcheck.o: bcheck.c
	$(CC) -o $@ -c $< -O2 -Wall

# install
TCC_INCLUDES = stdarg.h stddef.h stdbool.h float.h varargs.h tcclib.h
INSTALL=install

ifndef CONFIG_WIN32
install: $(PROGS) $(LIBTCC1) $(BCHECK_O) libtcc.a tcc.1 tcc-doc.html
	mkdir -p "$(bindir)"
	$(INSTALL) -s -m755 $(PROGS) "$(bindir)"
	mkdir -p "$(mandir)/man1"
	$(INSTALL) tcc.1 "$(mandir)/man1"
	mkdir -p "$(tccdir)"
	mkdir -p "$(tccdir)/include"
ifneq ($(LIBTCC1),)
	$(INSTALL) -m644 $(LIBTCC1) "$(tccdir)"
endif
ifneq ($(BCHECK_O),)
	$(INSTALL) -m644 $(BCHECK_O) "$(tccdir)"
endif
	$(INSTALL) -m644 $(addprefix include/,$(TCC_INCLUDES)) "$(tccdir)/include"
	mkdir -p "$(docdir)"
	$(INSTALL) -m644 tcc-doc.html "$(docdir)"
	mkdir -p "$(libdir)"
	$(INSTALL) -m644 libtcc.a "$(libdir)"
	mkdir -p "$(includedir)"
	$(INSTALL) -m644 libtcc.h "$(includedir)"

uninstall:
	rm -fv $(foreach P,$(PROGS),"$(bindir)/$P")
	rm -fv $(foreach P,$(LIBTCC1) $(BCHECK_O),"$(tccdir)/$P")
	rm -fv $(foreach P,$(TCC_INCLUDES),"$(tccdir)/include/$P")
	rm -fv "$(docdir)/tcc-doc.html" "$(mandir)/man1/tcc.1"
	rm -fv "$(libdir)/libtcc.a" "$(includedir)/libtcc.h"

else
install: $(PROGS) $(LIBTCC1) libtcc.a tcc-doc.html
	mkdir -p "$(tccdir)"
	mkdir -p "$(tccdir)/lib"
	mkdir -p "$(tccdir)/include"
	mkdir -p "$(tccdir)/examples"
	mkdir -p "$(tccdir)/doc"
	mkdir -p "$(tccdir)/libtcc"
	$(INSTALL) -s -m755 $(PROGS) "$(tccdir)"
	$(INSTALL) -m644 $(LIBTCC1) win32/lib/*.def "$(tccdir)/lib"
	cp -r win32/include/. "$(tccdir)/include"
	cp -r win32/examples/. "$(tccdir)/examples"
#	$(INSTALL) -m644 $(addprefix include/,$(TCC_INCLUDES)) "$(tccdir)/include"
	$(INSTALL) -m644 tcc-doc.html win32/tcc-win32.txt "$(tccdir)/doc"
	$(INSTALL) -m644 libtcc.a libtcc.h "$(tccdir)/libtcc"
endif

# documentation and man page
tcc-doc.html: tcc-doc.texi
	-texi2html -monolithic -number $<

tcc.1: tcc-doc.texi
	-./texi2pod.pl $< tcc.pod
	-pod2man --section=1 --center=" " --release=" " tcc.pod > $@

# tar release (use 'make -k tar' on a checkouted tree)
TCC-VERSION=tcc-$(shell cat VERSION)
tar:
	rm -rf /tmp/$(TCC-VERSION)
	cp -r . /tmp/$(TCC-VERSION)
	( cd /tmp ; tar zcvf ~/$(TCC-VERSION).tar.gz $(TCC-VERSION) --exclude CVS )
	rm -rf /tmp/$(TCC-VERSION)

# in tests subdir
test clean :
	$(MAKE) -C tests $@

# clean
clean: local_clean
local_clean:
	rm -vf $(PROGS) tcc_p$(EXESUF) tcc.pod *~ *.o *.a *.out libtcc_test$(EXESUF)

distclean: clean
	rm -vf config.h config.mak config.texi tcc.1 tcc-doc.html

endif # ifeq ($(TOP),.)

=== tests/Makefile ===
#
# Tiny C Compiler Makefile - tests
#

# what tests to run
TESTS = libtest test3

# these should work too
# TESTS += test1 test2 speed

# these don't work as they should
# TESTS += test4 btest asmtest


TOP = ..
include $(TOP)/Makefile

# run local version of tcc with local libraries and includes
TCC = ../tcc -B..
RUN_TCC = $(NATIVE_TARGET) -run ../tcc.c -B..
DISAS=objdump -d

all test : $(TESTS)

# make sure that tcc exists
$(TESTS) : ../tcc
../tcc ../libtcc.a :
	$(MAKE) -C ..

# libtcc test
libtest: libtcc_test$(EXESUF)
	@echo ------------ $@ ------------
	./libtcc_test lib_path=..

libtcc_test$(EXESUF): libtcc_test.c ../libtcc.a
	$(CC) -o $@ $^ -I.. $(CFLAGS) $(LIBS)

# test.ref - generate using gcc
test.ref: tcctest.c
	cp -u ../include/tcclib.h .
	$(CC) -o tcctest.gcc $< -I. -w $(CFLAGS)
	./tcctest.gcc > $@

# auto test
test1: test.ref
	@echo ------------ $@ ------------
	$(TCC) -run tcctest.c > test.out1
	@if diff -u test.ref test.out1 ; then echo "Auto Test OK"; fi

# iterated test2 (compile tcc then compile tcctest.c !)
test2: test.ref
	@echo ------------ $@ ------------
	$(TCC) $(RUN_TCC) $(RUN_TCC) -run tcctest.c > test.out2
	@if diff -u test.ref test.out2 ; then echo "Auto Test2 OK"; fi

# iterated test3 (compile tcc then compile tcc then compile tcctest.c !)
test3: test.ref
	@echo ------------ $@ ------------
	$(TCC) $(RUN_TCC) $(RUN_TCC) $(RUN_TCC) -run tcctest.c > test.out3
	@if diff -u test.ref test.out3 ; then echo "Auto Test3 OK"; fi

# binary output test
test4: test.ref
	@echo ------------ $@ ------------
# dynamic output
	$(TCC) -o tcctest1 tcctest.c
	./tcctest1 > test1.out
	@if diff -u test.ref test1.out ; then echo "Dynamic Auto Test OK"; fi
# object + link output
	$(TCC) -c -o tcctest3.o tcctest.c
	$(TCC) -o tcctest3 tcctest3.o
	./tcctest3 > test3.out
	@if diff -u test.ref test3.out ; then echo "Object Auto Test OK"; fi
# static output
	$(TCC) -static -o tcctest2 tcctest.c
	./tcctest2 > test2.out
	@if diff -u test.ref test2.out ; then echo "Static Auto Test OK"; fi
# dynamic output + bound check
	$(TCC) -b -o tcctest4 tcctest.c
	./tcctest4 > test4.out
	@if diff -u test.ref test4.out ; then echo "BCheck Auto Test OK"; fi

# memory and bound check auto test
BOUNDS_OK  = 1 4 8 10
BOUNDS_FAIL= 2 5 7 9 11 12 13

btest: boundtest.c
	@echo ------------ $@ ------------
	@for i in $(BOUNDS_OK); do \
	   if $(TCC) -b -run boundtest.c $$i ; then \
	       /bin/true ; \
	   else\
	       echo Failed positive test $$i ; exit 1 ; \
	   fi ;\
	done ;\
	for i in $(BOUNDS_FAIL); do \
	   if $(TCC) -b -run boundtest.c $$i ; then \
	       echo Failed negative test $$i ; exit 1 ;\
	   else\
	       /bin/true ; \
	   fi ;\
	done ;\
	echo Bound test OK

# speed test
speed: ex2 ex3
	@echo ------------ $@ ------------
	time ./ex2 1238 2 3 4 10 13 4
	time $(TCC) -run ../examples/ex2.c 1238 2 3 4 10 13 4
	time ./ex3 35
	time $(TCC) -run ../examples/ex3.c 35

ex%: ../examples/ex%.c
	$(CC) -o $@ $< $(CFLAGS)

# tiny assembler testing
asmtest.ref: asmtest.S
	$(CC) -o asmtest.ref.o -c asmtest.S
	objdump -D asmtest.ref.o > $@

asmtest: asmtest.ref
	@echo ------------ $@ ------------
	$(TCC) -c asmtest.S
	objdump -D asmtest.o > $@
	@if diff -u --ignore-matching-lines="file format" asmtest.ref asmtest.out ; then echo "ASM Auto Test OK"; fi

# targets for development
%.bin: %.c tcc
	$(TCC) -g -o $@ $<
	$(DISAS) $@

instr: instr.o
	objdump -d instr.o

instr.o: instr.S
	$(CC) -o $@ -c $< -O2 -Wall -g

cache: tcc_g
	cachegrind ./tcc_g -o /tmp/linpack -lm bench/linpack.c
	vg_annotate tcc.c > /tmp/linpack.cache.log

# clean
clean:
	rm -vf *~ *.o *.a *.bin *.i *.ref *.out *.out? *.gcc \
	   tcctest[1234] ex? libtcc_test$(EXESUF) tcc_g tcclib.h

=== debian/changelog ===
tcc (0.9.25-6) unstable; urgency=low

  * Reactivate support for armel arch.
  * Attempt to solve test suite failure on armel.
  * Register documentation with doc-base.
  * Fix the license of win32/tools/tiny_libmaker.c with author's agreement.
  * Convert package to multiarch.
  * debian/patches:
    + Stricter test about declaration of static function without file scope in
      local block to not error out in wrong situations (regression fix).
    + Add function and variable assembly labels.
  * debian/compat:
    + Bump debhelper compatibility from 7 to 8 (no changes needed).
  * debian/copyright:
    + Update and convert to DEP5 candidate format.
    + Update address of FSF.
    + Remove duplicate notices and give redistribution license.
  * debian/control:
    + Bump Standards-Version to 3.9.2 (no changes needed).
    + Improve synopsis wording for tcc.
  * Remove useless debian/tcc.dirs file

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 18 Oct 2010 15:58:01 +0200

tcc (0.9.25-5) unstable; urgency=low

  * Drop support for armel arch.

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 05 Sep 2010 23:15:47 +0200

tcc (0.9.25-4) unstable; urgency=low

  * Fix bashims in configure and gcctestsuite.sh.
  * Add support for indirect functions as externals.
  * Bump Standard-Version from 3.8.4 to 3.9.1 (no changes needed).
  * debian/control:
    - Improve package description for libtcc-dev.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 10 Aug 2010 00:10:30 +0200

tcc (0.9.25-3) unstable; urgency=low

  * Change Vcs fields to reference Alioth.
  * Don't load libtcc1.a if not available (fix a FTBFS on armel).
  * Link alias symbols together. (Closes: #452876)
  * Support C99 Variable-Length Arrays. (Closes: #439135)

 -- Thomas Preud'homme <robotux@celest.fr>  Sat, 01 May 2010 23:44:46 +0200

tcc (0.9.25-2) unstable; urgency=low

  * Make tcc build on armv5tel, armv6j and armv7a architectures.
  * Clean patches submitted upstream following upstream advice.
  * Also clean 438097_configure_allow_nostrip.diff patch.
  * Convert patches to DEP3 patch format.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 20 Apr 2010 22:44:37 +0200

tcc (0.9.25-1) unstable; urgency=low

  * New upstream release (Closes: #549100, LP: #500296).
    - Supports amd64 architecture.
  * Fix Hurd FTBFS (Closes: #532503).
  * Improve tcc handling of ld scripts: libs in GROUP command are
    searched repeatedly, as required.
  * Add support for kfreebsd-amd64.
  * Cherry-pick 55cb217 from upstream to fix incorrect elf output on
    FreeBSD kernels.
  * Make the package compile on armel (Closes: #506517).
  * x86_64_alloca.diff: Add alloca on x86-64, from upstream commits
    8ea8305 and dca2b15, to fix a test failure.
  * 528902_texi_direntry.diff: Add @dircategory and @direntry
    (Closes: #528902).
  * Complain for static fct declared without file scope
    (Closes: #170105).
  * Install the libtcc library in the new libtcc-dev package
    (Closes: #234245).
  * Remove unnecessary patches.
    - 322913_fix_casts_from_fp_to_bool.diff (already fixed in 0.9.24)
    - 474883_fix_segmentation_fault_when_compiling.diff
    - tcc-doc_texi_formatting.diff
  * Rewrite 419203_fix_sizeof_parse_error.diff patch.
  * Rebase patch on tcc version 0.9.25.
  * Add debian/watch file.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Add DESTDIR support in configure script.
  * Move info file creation from debian/rules to upstream Makefile.
  * Use a dh based debian/rule Makefile.
  * Bump debhelper compatibility from 4 to 7 (no changes needed).
  * Bump Standard-Version from 3.8.0 to 3.8.4 (no changes needed).
  * Fill Vcs-Browser and Vcs-Git fields.
  * Correctly support DEB_BUILD_OPTIONS.
  * Don't rebuild the package if it was already built before.

 -- Thomas Preud'homme <robotux@celest.fr>  Sat, 17 Apr 2010 20:41:12 +0200

tcc (0.9.24-1) unstable; urgency=high

  [ Aurélien GÉRÔME ]
  * Change my email address in the Maintainer field.
  * Bump Standards-Version to 3.8.0.
  * Remove no longer used XS-Vcs-Git and XS-Vcs-Browser fields.
  * Add the DM-Upload-Allowed field for Arthur.

  [ Thomas Preud'homme ]
  * New Upstream Version
    - tcc now supports typename as structure field name (closes: #278698)
    - A long long value used as a test expression ignores the
      upper 32 bits at runtime (closes: #304082)
  * Remove unecessary patches:
    - 352202_fix_int_overflow.diff
    - 283066_add_va_copy_define.diff (already disabled)
    - 430209_fix_bound_check_error.diff
  * Clean all patches (no fuzz or offset problem anymore)
  * Add patch from Bradley Smith to allow compilation with gcc 4.3
    (closes: #474883)
  * Add tcc-doc_texi_formatting.diff to correct formatting of tcc-doc.texi

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 16 Jun 2008 03:31:38 +0200

tcc (0.9.24~cvs20070502-2) unstable; urgency=low

  * 430209_fix_bound_check_error.diff: Add. (Closes: #430209)
    - Thanks to Thomas Preud'homme.
  * 438097_configure_allow_nostrip.diff: Add. (Closes: #438097)
  * Add myself to Uploaders, update debian/copyright accordingly.
  * debian/control: Use the new Homepage field.
  * Port on hurd-i386:
    - patches/series/hurd.diff: Add.
    - debian/control: Update Architecture list.

 -- Arthur Loiret <arthur.loiret@gmail.com>  Fri, 12 Oct 2007 04:31:48 +0200

tcc (0.9.24~cvs20070502-1) unstable; urgency=low

  [ Aurélien GÉRÔME ]
  * New maintainer and co-maintainer. (Closes: #420643)
  * Add the XS-Vcs-Git and XS-Vcs-Browser fields to debian/control.
  * Update homepage with the tiny URL in debian/control.
  * Remove unused ${misc:Depends} from debian/control.
  * Short description in debian/control is not a sentence, so start
    by a lowercase.
  * Remove unused debhelper tools from debian/rules.
  * Run test suite in debian/rules.
  * Remove .pc/ directory after build in the clean target of
    debian/rules.
  * Update debian/copyright.
  * TinyCC is no longer maintained upstream: use the latest CVS which


=== debian/control ===
Source: tcc
Section: devel
Priority: optional
Maintainer: Aurélien GÉRÔME <ag@debian.org>
Uploaders: Thomas Preud'homme <robotux@celest.fr>, Arthur Loiret <arthur.loiret@gmail.com>
Build-Depends: debhelper (>= 8.1.3), texi2html, texinfo, perl
Standards-Version: 3.9.2
Homepage: http://www.tinycc.org/
DM-Upload-Allowed: yes
Vcs-Browser: http://git.debian.org/?p=collab-maint/tcc.git;a=summary
Vcs-Git: git://git.debian.org/collab-maint/tcc.git

Package: tcc
Architecture: i386 kfreebsd-i386 hurd-i386 amd64 kfreebsd-amd64 armel
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Provides: c-compiler
Description: Small ANSI C compiler
 TCC (for Tiny C Compiler) is a small and fast ANSI C compiler.  It
 generates optimized x86 code, and can compile, assemble, and link
 several times faster than 'gcc -O0'.  Any C dynamic library can be used
 directly.  It includes an optional memory and bounds checker, and
 bounds-checked code can be mixed freely with standard code.  C script
 is also supported via the usual hash-bang mechanism.
 .
 NOTE: TCC is still somewhat experimental and is not recommended for
 production use.  The code it generates is much less optimized than what
 GCC produces, and compiler bugs can have serious security consequences
 for your program.

Package: libtcc-dev
Section: libdevel
Architecture: i386 kfreebsd-i386 hurd-i386 amd64 kfreebsd-amd64 armel
Depends: ${misc:Depends}
Description: Fast library for dynamic code generation
 Libtcc is a library that uses tcc, a compiler several times faster than
 'gcc -O0' to perform dynamic code generation. It exposes in its API all
 operations tcc performs to generate a binary from sources: setting
 header and library paths, compiling program from a source file,
 manipulating its symbols and handling relocation of its code among
 other things. Libtcc is also able to compile from a buffer.
 .
 This package contains the static library and header file for TCC (Tiny
 C Compiler).
 .
 NOTE: libtcc is still somewhat experimental and is not recommended for
 production use.  The code it generates is much less optimized than what
 GCC produces, and compiler bugs can have serious security consequences
 for your program.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_configure:
	dh_auto_configure -- --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

clean:
	rm -f build
	dh clean

build:
	dh build
	touch build # As recommended by policy 3.8.4 section 4.9

%:
	dh $@
